
/*
 *      writed by kir http://paradox.org.ua
 */

#ifndef _adapter_h_
#define _adapter_h_

class CTTSpciIoIrq;
class CTTSpciI2C;
class CTTSpciDebi;

class CNetDev;
class CTSDemux;

class CTuner;
class CFifo;
class CFifoDemux;

struct dmaspace
{
        unsigned char   *vbuffer;
        unsigned long   pbuffer;
        unsigned long   size;
};

typedef void    (*ISRFN)(void *);
#define SETISRFN(x)     reinterpret_cast<ISRFN>(x)

class CDvbAdapter
{
protected:
	device_t        device;

	unsigned long   idVendor;       //0x1131        Philips
	unsigned long   idDevice;       //0x7146        SAA7146

	unsigned long   idSubVendor;	//+176	//0x13C2        TechoTrend
	unsigned long   idSubDevice;    //......

//bus io
	struct resource *rmem;
//bus irq
	struct resource *rirq;
	void		*rih;

	struct dmaspace	dma;

	CFifoDemux	*fifodemux;

	CTTSpciIoIrq	*pci;
	CTTSpciI2C	*i2c;
	CTTSpciDebi	*debi;

	CNetDev		*net;
	CTSDemux	*tsdemux;

	CTuner		*tuner;

	CFifo		*tsfifo;

	unsigned long	DMAStatus;

	unsigned long   CiISR;
	unsigned long   IrISR;
	unsigned long   DataISR;

	unsigned long	NoSecCSum;
	unsigned long	BadSecCSum;
	unsigned long	BadSecCRC;
	unsigned long	NotMPE;	
	unsigned long	Scrmbl;
	unsigned long	NotIP;
	unsigned long	SecBadL;
	unsigned long	FltBadL;
	

	unsigned long	HWIRQ;
	unsigned long	MyIRQ;
	unsigned long	DPC;
	unsigned long	DPCReq;
	unsigned long   IRQCb;
	unsigned long   EvenFields;
	unsigned long   OddFields;

	unsigned long	TSABCb;	

	unsigned long	MyHW;

	unsigned long	FifoFull;

	unsigned long   MACAddressOID;
	unsigned long   MACAddressL3B;

	unsigned char   MACAddress[6];

public:
	CDvbAdapter(device_t dev);
	~CDvbAdapter();

	void	Dump(void);

	int	I2CReadSeq(int slave, unsigned char *readBuf, int readLen);
	int	I2CWriteSeq(int slave, unsigned char *writeBuf, int writeLen);
	int	I2CCombinedSeq(int slave,
        			unsigned char *writeBuf, int writeLen, unsigned char *readBuf, int readLen);

	int	CreateTuner(int subdevice);

	void	TSCallback(unsigned char filterType, unsigned char filterNo, unsigned char *data, unsigned long len, unsigned char flag);

	void	HWIsrCallback(unsigned long irqtype, unsigned long isrnum);
	int	HWEnableDataDMA(void);
	int	HWDisableDataDMA(void);
	int	HWReadMAC(unsigned long *macOID, unsigned long *macL3B);

	int	HWInstallInterrupt( void (*ISRHandler)(void *) );
	void	HWRemoveInterrupt(void);

	static void	HWInterruptService(CDvbAdapter *dvb);

	int	HWSetup7146IoSpace(void);
	void	HWRemove7146IoSpace(void);

	int	HWSetupSharedMemory(void);
	void	HWRemoveSharedMemory(void);

	void	HWInit7146Register(int ci);

	int	HWDeInitialize(int level);
	int	HWInitialize(int subdevice);

	static	int	HWDvbControl(CDvbAdapter *dvb, struct dvbapi *parm);
};

#endif
