
/*
 *      writed by kir http://paradox.org.ua
 */

#ifndef _pci_h_
#define _pci_h_

struct ISRTable
{
	unsigned long	isrtype;
	unsigned long	isrnum;
	unsigned long	irqtype;
	void		*data;
};

class CTTSpciIoIrq
{
protected:

	struct resource	*memory;

	unsigned long	isrnum;	
	unsigned long	spin;
	unsigned long	irq;

	unsigned short		isrTableSize;
	struct	ISRTable	isrTableEntry[32];

public:
	CTTSpciIoIrq(struct resource *memory);
	~CTTSpciIoIrq();

	void	Init(void);

	void	DeviceReset(void);

	unsigned long	GetUploadMask(int reg);
	void	UploadRegs(unsigned long mask);

	unsigned long	GetReg(int reg);
	void	SetReg(int reg, unsigned long value, int upload);

	void	SetOut22KHzLine(int state);
	int	GetOut22HKzLine(void);

	void	SetResetLine(int state);
	int	GetResetLine(void);

	void	SetGPIO(int gpioPin, int gpioMode);
	int	GetGPIO(int gpioPin);

	unsigned long	EnableIrq(unsigned long irqtype);
	unsigned long	DisableIrq(unsigned long irqtype);

	void	PhysicalEnable(void);
	void	PhysicalDisable(void);


	int	RegisterIsr(unsigned long irqtype, void *data, unsigned long isrtype, unsigned short *isrSize, struct ISRTable *isrTable);
	int	RegisterRing0Isr(unsigned long irqtype, void *data, unsigned long isrtype);


	int	ScanIsrTable(unsigned long isrnum, unsigned short *isrSize, struct ISRTable *isrTable);
	int	UnregisterIsr(unsigned long isrnum);

	unsigned long	CallRing0Isrs(unsigned long irqtype);

	int	OnHardwareInt(void);
};

#endif

